import pandas as pd
from __future__ import print_function
pd.set_option('display.max_columns', 500)

import numpy as np
import sys,os
names = ["str1","chr1", "pos1", "frag1", "str2", "chr2", "pos2", "frag2", "mapq1", "cigar1",
                 "sequence1", "mapq2", "cigar2", "sequence2", "readname1", "readname2"]
a = pd.read_csv(sys.argv[1],sep=" ",names=names, header=None, index_col=False)
#print ("Done! Data looks like: ")
#print (a.head())
#print ("Calculating read orientations....")
mq = int(sys.argv[2])
a.query("mapq1>=@mq & mapq2>=@mq", inplace=True)
a["orient"] = a["str1"] - a["str2"]
a.loc[a["pos1"]<a["pos2"],"orient"] = a["str2"] - a["str1"]
a.loc[a["chr1"]!=a["chr2"],"orient"] = -1
#a["orient"] = a.apply(orientation, axis="columns")
a["dist"] = (a.pos2-a.pos1).abs()
a["fdist"] = (a.frag2-a.frag1).abs()
assert np.all(a.dist >= 0)

#print("Orientations:")
#print(a["orient"].value_counts())
#print(a["orient"].value_counts()/a["orient"].value_counts().sum())
vc = a["orient"].value_counts()
trans_of_all = vc.loc[-1]*100/vc.sum()
trans_of_cisHiC = vc.loc[-1]*100/vc.loc[0]
HiC_of_cis = vc.loc[0]*100/(vc.sum()-vc.loc[-1])
print(os.path.basename(sys.argv[1]),sys.argv[2],trans_of_all,trans_of_cisHiC,HiC_of_cis)
sys.exit()
raise
b = a.query("chr1==chr2")
print ("dist <=150 : ", len(b.query("dist <= 150"))/len(b))
print ("dist <=450 : ", len(b.query("dist <= 450"))/len(b))
print ("dist <=450 : ", len(b.query("dist <= 1000"))/len(b))

print ("neighbor frag: ", len(b.query("fdist <= 1"))/len(b))
print ("neighbor frag 2: ", len(b.query("fdist <= 2"))/len(b))


print ("---drop FR---")
a = a.query("pos2 - pos1 >= 1000 | orient != 16")
print(a["orient"].value_counts())
"""
print ("dist <=150 : ", len(a.query("abs(pos2 - pos1) <= 150"))/len(a))

print ("dist <=450 : ", len(a.query("abs(pos2 - pos1 <= 450"))/len(a))

print ("dist <=450 : ", len(a.query("pos2 - pos1 <= 1000"))/len(a))

print ("neighbor frag: ", len(a.query("frag2 - frag1 == 1"))/len(a))
"""
